From a5cd6c8133be4a84583b97f6e72929b0bfbdf3bc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 24 2020 14:51:16 +0000
Subject: [PATCH 918/2232] Merge pull request #318 from dtolnay/_h


Assume header output for paths ending in .h
---

diff --git a/gen/cmd/src/app.rs b/gen/cmd/src/app.rs
index caab254..44e30bb 100644
--- a/gen/cmd/src/app.rs
+++ b/gen/cmd/src/app.rs
@@ -102,9 +102,11 @@ these C++ functions in another.
 }
 
 fn arg_header() -> Arg {
-    Arg::with_name(HEADER)
-        .long(HEADER)
-        .help("Emit header with declarations only.")
+    const HELP: &str = "\
+Emit header with declarations only. Optional if using `-o` with
+a path ending in `.h`.
+    ";
+    Arg::with_name(HEADER).long(HEADER).help(HELP)
 }
 
 fn arg_include() -> Arg {
diff --git a/gen/cmd/src/main.rs b/gen/cmd/src/main.rs
index 834b738..12e173e 100644
--- a/gen/cmd/src/main.rs
+++ b/gen/cmd/src/main.rs
@@ -9,10 +9,12 @@
 
 mod app;
 mod gen;
+mod output;
 mod syntax;
 
-use gen::error::{report, Result};
-use gen::{fs, include};
+use crate::gen::error::{report, Result};
+use crate::gen::{fs, include};
+use crate::output::Output;
 use std::io::{self, Write};
 use std::path::PathBuf;
 use std::process;
@@ -26,12 +28,6 @@ struct Opt {
     output: Output,
 }
 
-#[derive(Debug)]
-enum Output {
-    Stdout,
-    File(PathBuf),
-}
-
 fn main() {
     if let Err(err) = try_main() {
         let _ = writeln!(io::stderr(), "cxxbridge: {}", report(err));
@@ -42,15 +38,17 @@ fn main() {
 fn try_main() -> Result<()> {
     let opt = app::from_args();
 
+    let gen_header = opt.header || opt.output.ends_with(".h");
+
     let gen = gen::Opt {
         include: opt.include,
         cxx_impl_annotations: opt.cxx_impl_annotations,
-        gen_header: opt.header,
-        gen_implementation: !opt.header,
+        gen_header,
+        gen_implementation: !gen_header,
     };
 
     let content;
-    let content = match (opt.input, opt.header) {
+    let content = match (opt.input, gen_header) {
         (Some(input), true) => {
             content = gen::generate_from_path(&input, &gen).header;
             content.as_slice()
diff --git a/gen/cmd/src/output.rs b/gen/cmd/src/output.rs
new file mode 100644
index 0000000..a46581b
--- /dev/null
+++ b/gen/cmd/src/output.rs
@@ -0,0 +1,16 @@
+use std::path::PathBuf;
+
+#[derive(Debug)]
+pub(crate) enum Output {
+    Stdout,
+    File(PathBuf),
+}
+
+impl Output {
+    pub(crate) fn ends_with(&self, suffix: &str) -> bool {
+        match self {
+            Output::Stdout => false,
+            Output::File(path) => path.to_string_lossy().ends_with(suffix),
+        }
+    }
+}
diff --git a/gen/cmd/src/test.rs b/gen/cmd/src/test.rs
index 76101d9..2e85fac 100644
--- a/gen/cmd/src/test.rs
+++ b/gen/cmd/src/test.rs
@@ -24,8 +24,9 @@ OPTIONS:
             Print help information.
 
         --header
-            Emit header with declarations only.
-
+            Emit header with declarations only. Optional if using `-o` with
+            a path ending in `.h`.
+               \x20
     -i, --include <include>...
             Any additional headers to #include. The cxxbridge tool does not
             parse or even require the given paths to exist; they simply go

